## xenomai 2.5.5.2

=== examples/common/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = hw_direct_io

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES =

### Note: to override the kernel source path, use "make KSRC=..."



###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=$(shell $(XENOCONFIG) --xeno-cflags) $(MY_CFLAGS)

LDFLAGS=$(shell $(XENOCONFIG) --xeno-ldflags) $(MY_LDFLAGS) -O

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6
ifeq ($(findstring 2.6,$(KSRC)),2.6)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) SUBDIRS=$(PWD) modules

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers Module.markers modules.order
	$(RM) -R .tmp*

endif

=== examples/native/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = trivial-periodic sigdebug rtprint

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES =

### Note: to override the kernel source path, use "make KSRC=..."



###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=$(shell $(XENOCONFIG) --xeno-cflags) $(MY_CFLAGS)

LDFLAGS=$(shell $(XENOCONFIG) --xeno-ldflags) $(MY_LDFLAGS) -lnative

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### SPECIAL TARGET RULES ######
rtprint: rtprint.c
	$(CC) $(CFLAGS) $? $(LDFLAGS) -lrtdk -o $@



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6
ifeq ($(findstring 2.6,$(KSRC)),2.6)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) SUBDIRS=$(PWD) modules

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers Module.markers modules.order
	$(RM) -R .tmp*

endif

=== examples/posix/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = satch

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES = satch

### Note: to override the kernel source path, use "make KSRC=..."

all::

satch: satch.c


###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=-DCONSUMER $(shell $(XENOCONFIG) --posix-cflags) $(APP_CFLAGS)

LDFLAGS=$(shell $(XENOCONFIG) --posix-ldflags) $(APP_LDFLAGS)

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6
PATCHLEVEL:=$(shell sed 's/PATCHLEVEL = \(.*\)/\1/;t;d' $(KSRC)/Makefile)
ifeq ($(PATCHLEVEL),6)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -DPRODUCER -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) ARCH=$(ARCH) CROSS_COMPILE=$(CROSS_COMPILE) SUBDIRS=$(PWD) modules
	$(RM) *.o

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers Module.markers modules.order
	$(RM) -R .tmp*
	$(RM) .runinfo

endif

=== ksrc/drivers/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENOMAI) += serial/ testing/ can/ analogy/ ipc/

else

# Makefile frag for Linux v2.4

mod-subdirs := serial testing can analogy ipc

subdir-$(CONFIG_XENO_DRIVERS_16550A) += serial

subdir-$(CONFIG_XENO_DRIVERS_TIMERBENCH) += testing
subdir-$(CONFIG_XENO_DRIVERS_IRQBENCH)   += testing
subdir-$(CONFIG_XENO_DRIVERS_SWITCHTEST) += testing

subdir-$(CONFIG_XENO_DRIVERS_CAN) += can
subdir-$(CONFIG_XENO_DRIVERS_ANALOGY) += analogy
subdir-$(CONFIG_XENO_DRIVERS_MPIPE) += ipc

include $(TOPDIR)/Rules.make

endif

=== ksrc/nucleus/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENO_OPT_NUCLEUS) += xeno_nucleus.o

xeno_nucleus-y := \
	bufd.o heap.o intr.o pod.o registry.o \
	synch.o thread.o timebase.o timer.o sched.o \
	sched-idle.o sched-rt.o

xeno_nucleus-$(CONFIG_XENO_OPT_SCHED_SPORADIC) += sched-sporadic.o
xeno_nucleus-$(CONFIG_XENO_OPT_SCHED_TP) += sched-tp.o

xeno_nucleus-$(CONFIG_XENO_OPT_PERVASIVE) += shadow.o
xeno_nucleus-$(CONFIG_XENO_OPT_PIPE) += pipe.o
xeno_nucleus-$(CONFIG_XENO_OPT_MAP) += map.o
xeno_nucleus-$(CONFIG_XENO_OPT_SELECT) += select.o

# CAUTION: this module shall appear last, so that dependencies may
# exist on initcalls defined by other object files.
xeno_nucleus-y += module.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_OPT_NUCLEUS) := xeno_nucleus.o

list-multi := xeno_nucleus.o

xeno_nucleus-objs := \
	bufd.o heap.o intr.o pod.o registry.o \
	synch.o thread.o timebase.o timer.o sched.o \
	sched-idle.o sched-rt.o

opt_objs-$(CONFIG_XENO_OPT_SCHED_SPORADIC) += sched-sporadic.o
opt_objs-$(CONFIG_XENO_OPT_SCHED_TP) += sched-tp.o

opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += shadow.o
opt_objs-$(CONFIG_XENO_OPT_PIPE) += pipe.o
opt_objs-$(CONFIG_XENO_OPT_MAP) += map.o
opt_objs-$(CONFIG_XENO_OPT_SELECT) += select.o

xeno_nucleus-objs += $(opt_objs-y)

# CAUTION: this module shall appear last, so that dependencies may
# exist on initcalls defined by other object files.
xeno_nucleus-objs += module.o

export-objs := $(xeno_nucleus-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_nucleus.o: $(xeno_nucleus-objs)
	$(LD) -r -o $@ $(xeno_nucleus-objs)

endif

=== examples/rtdm/driver-api/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = tut01-skeleton-app tut02-skeleton-app

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES = heartbeat tut01-skeleton-drv tut02-skeleton-drv

### Note: to override the kernel source path, use "make KSRC=..."



###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=$(shell $(XENOCONFIG) --xeno-cflags) $(MY_CFLAGS)

LDFLAGS=$(shell $(XENOCONFIG) --xeno-ldflags) $(MY_LDFLAGS) -lnative -lrtdm

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6
ifeq ($(findstring 2.6,$(KSRC)),2.6)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) SUBDIRS=$(PWD) modules

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers Module.markers modules.order
	$(RM) -R .tmp*

endif

=== ksrc/arch/blackfin/Makefile ===

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal.o switch.o

ifndef CONFIG_SMP
xeno_hal-y += atomic.o
endif

xeno_hal-$(CONFIG_XENO_HW_NMI_DEBUG_LATENCY) += nmi.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

=== ksrc/arch/generic/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal.o

xeno_hal-$(CONFIG_XENO_HW_NMI_DEBUG_LATENCY) += nmi.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-y := hal.o compat.o

obj-$(CONFIG_XENO_HW_NMI_DEBUG_LATENCY) += nmi.o

export-objs := $(obj-y)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

endif

=== ksrc/arch/powerpc/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal.o
xeno_hal-$(CONFIG_XENO_HW_FPU) += fpu.o

ifeq ($(CONFIG_PPC64),y)
xeno_hal-$(CONFIG_PPC64) += switch_64.o
else
xeno_hal-$(CONFIG_PPC) += switch_32.o
endif

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

USE_STANDARD_AS_RULE := true

O_TARGET := built-in.o

obj-y := hal.o
obj-$(CONFIG_XENO_HW_FPU) += fpu.o

ifeq ($(CONFIG_PPC64),y)
obj-y += switch_64.o
else
obj-y += switch_32.o
endif

export-objs := hal.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

EXTRA_AFLAGS += -I$(TOPDIR)/arch/ppc/kernel

include $(TOPDIR)/Rules.make

endif

=== ksrc/arch/x86/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

ifeq ($(CONFIG_X86_64),y)
X86_MODE := 64
else
X86_MODE := 32
endif

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal_$(X86_MODE).o hal-common.o usercopy_$(X86_MODE).o

xeno_hal-$(CONFIG_XENO_HW_NMI_DEBUG_LATENCY) += nmi.o

xeno_hal-$(CONFIG_XENO_HW_SMI_DETECT) += smi.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

USE_STANDARD_AS_RULE := true

O_TARGET := built-in.o

obj-y := hal_32.o hal-common.o

obj-$(CONFIG_XENO_HW_NMI_DEBUG_LATENCY) += nmi.o

obj-$(CONFIG_XENO_HW_SMI_DETECT) += smi.o

export-objs := $(obj-y) $(obj-m)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

endif

=== ksrc/drivers/analogy/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai -Idrivers/xenomai/analogy

obj-$(CONFIG_XENO_DRIVERS_ANALOGY) += xeno_analogy.o testing/ intel/ national_instruments/ sensoray/

xeno_analogy-y := \
	buffer.o \
	command.o \
	device.o \
	driver.o \
	driver_facilities.o \
	instruction.o \
	os_facilities.o \
	subdevice.o \
	transfer.o

xeno_analogy-$(CONFIG_XENO_OPT_PERVASIVE) += rtdm_interface.o

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

subdir-$(CONFIG_XENO_DRIVERS_ANALOGY_FAKE) += testing
subdir-$(CONFIG_XENO_DRIVERS_ANALOGY_LOOP) += testing
subdir-$(CONFIG_XENO_DRIVERS_ANALOGY_8255) += intel
subdir-$(CONFIG_XENO_DRIVERS_ANALOGY_NI_MITE) += national_instruments
subdir-$(CONFIG_XENO_DRIVERS_ANALOGY_S526) += sensoray

obj-$(CONFIG_XENO_DRIVERS_ANALOGY) += xeno_analogy.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += rtdm_interface.o

xeno_analogy-objs := \
	buffer.o \
	command.o \
	device.o \
	driver.o \
	driver_facilities.o \
	instruction.o \
	os_facilities.o \
	subdevice.o \
	transfer.o

xeno_analogy-objs += $(opt_objs-y)

export-objs := $(xeno_analogy-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat -I.

include $(TOPDIR)/Rules.make

xeno_analogy.o: $(xeno_analogy-objs)
	$(LD) -r -o $@ $(xeno_analogy-objs)

endif

=== ksrc/drivers/can/Makefile ===
ifeq ($(PATCHLEVEL),6)

# Makefile frag for Linux v2.6

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai -Idrivers/xenomai/can

obj-$(CONFIG_XENO_DRIVERS_CAN) += xeno_can.o mscan/ sja1000/
obj-$(CONFIG_XENO_DRIVERS_CAN_VIRT) += xeno_can_virt.o

xeno_can-y := rtcan_dev.o rtcan_socket.o rtcan_module.o rtcan_raw.o rtcan_raw_dev.o rtcan_raw_filter.o
xeno_can_virt-y := rtcan_virt.o

else

# Makefile frag for Linux v2.4

mod-subdirs := mscan sja1000

subdir-$(CONFIG_XENO_DRIVERS_CAN_MSCAN) += mscan
subdir-$(CONFIG_XENO_DRIVERS_CAN_SJA1000) += sja1000

O_TARGET := built-in.o

obj-$(CONFIG_XENO_DRIVERS_CAN) += xeno_can.o
obj-$(CONFIG_XENO_DRIVERS_CAN_VIRT) += xeno_can_virt.o

list-multi := xeno_can.o

xeno_can-objs := rtcan_dev.o rtcan_socket.o rtcan_module.o rtcan_raw.o rtcan_raw_dev.o rtcan_raw_filter.o
xeno_can_virt-objs := rtcan_virt.o

export-objs := $(xeno_can-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat -I.

include $(TOPDIR)/Rules.make

xeno_can.o: $(xeno_can-objs)
	$(LD) -r -o $@ $(xeno_can-objs)

xeno_can_virt.o: $(xeno_can_virt-objs)
	$(LD) -r -o $@ $(xeno_can_virt-objs)

endif

=== debian/changelog ===
xenomai (2.5.5.2-1ubuntu2) natty; urgency=low

  * debian/patches/fix_thumb_build.patch: Add IF-THEN instruction
    to fix Thumb-2 build on armel.
  * debian/rules: Set OMAP3 as default target machine as that is
    the closest to what we support from what upstream configure script
    has to offer.

 -- Jani Monoses <jani@ubuntu.com>  Mon, 28 Mar 2011 22:55:28 +0300

xenomai (2.5.5.2-1ubuntu1) natty; urgency=low

  * Merge from debian unstable.  Remaining changes:
    - debian/rules: Create file for debhelper to pick up, use debhelper to
      install it.
    - debian/libxenomai1.preinst: Remove symlink on upgrade, remove old udev.
      rule unless modified in which case move to new name.
    - debian/libxenomai1.postinst: Do not create symlink.
    - debian/libxenomai1.postrm: No symlink to remove.
    - debian/control: Add Breaks on udev to get correct version.

 -- Artur Rona <ari-tczew@ubuntu.com>  Wed, 22 Dec 2010 14:25:48 +0100

xenomai (2.5.5.2-1) unstable; urgency=low

  * New upstream release (Closes: #593585, #593586)
  * Using scripts/prepare-patch.sh now instead of debian/prepare-patch.sh

 -- Roland Stigge <stigge@antcom.de>  Sun, 12 Dec 2010 19:45:39 +0100

xenomai (2.5.4-3ubuntu1) natty; urgency=low

  * Merge from debian unstable.  Remaining changes:
    - debian/rules: Create file for debhelper to pick up, use debhelper to
      install it.
    - debian/libxenomai1.preinst: Remove symlink on upgrade, remove old udev.
      rule unless modified in which case move to new name.
    - debian/libxenomai1.postinst: Do not create symlink.
    - debian/libxenomai1.postrm: No symlink to remove.
    - debian/control: add Breaks on udev to get correct version.
  * New upstream release fixes issue:
    - Support higher kernel than 2.6.29. (LP: #544284)

 -- Artur Rona <ari-tczew@ubuntu.com>  Sat, 16 Oct 2010 00:25:10 +0200

xenomai (2.4.8-2ubuntu1) karmic; urgency=low

  * Merge from debian unstable (LP: #391918), remaining changes:
    - Add lpia to supported architectures.
    - debian/rules: Create file for debhelper to pick up, use debhelper to
      install it.
    - debian/libxenomai1.dirs: Do not create directory.
    - debian/libxenomai1.preinst: Remove symlink on upgrade, remove old udev.
      rule unless modified in which case move to new name.
    - debian/libxenomai1.postinst: Do not create symlink.
    - debian/libxenomai1.postrm: No symlink to remove.
    - Bump build-depend on debhelper to install udev rules into
      /lib/udev/rules.d, add Breaks on udev to get correct version.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 24 Jun 2009 22:17:01 -0500

xenomai (2.4.4-3ubuntu3) jaunty; urgency=low

  * debian/rules: Create file for debhelper to pick up, use debhelper to
    install it
  * debian/libxenomai1.dirs: Do not create directory
  * debian/libxenomai1.preinst: Remove symlink on upgrade, remove old udev
    rule unless modified in which case move to new name.
  * debian/libxenomai1.postinst: Do not create symlink
  * debian/libxenomai1.postrm: No symlink to remove
  * Bump build-depend on debhelper to install udev rules into
    /lib/udev/rules.d, add Breaks on udev to get correct version.

 -- Scott James Remnant <scott@ubuntu.com>  Tue, 13 Jan 2009 16:51:22 +0000

xenomai (2.4.4-3ubuntu2) intrepid; urgency=low

  * Add lpia to supported architectures.

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Tue, 26 Aug 2008 15:35:26 +0000

xenomai (2.4.4-3ubuntu1) intrepid; urgency=low

  * Include limits.h in these files, fix FTBFS with glibc 2.8:
    - src/testsuite/irqbench/irqloop.c
    - src/testsuite/switchtest/switchtest.c:

 -- Luca Falavigna <dktrkranz@ubuntu.com>  Tue, 26 Aug 2008 15:18:20 +0000

=== debian/control ===
Source: xenomai
Section: devel
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 7), dh-kpatches, findutils (>= 4.2.28)
Standards-Version: 3.9.1
Homepage: http://www.xenomai.org/

Package: xenomai-runtime
Section: devel
Architecture: amd64 arm armeb armel i386 powerpc
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: linux-patch-xenomai, xenomai-doc
Replaces: xenomai
Conflicts: xenomai
Description: Xenomai runtime utilities
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains the runtime programs and the testsuite for the Xenomai
 realtime system.

Package: linux-patch-xenomai
Section: kernel
Architecture: all
Depends: ${kpatch:Depends}, ${misc:Depends}
Suggests: xenomai, linux-source-2.6, kernel-package
Description: Linux kernel patches for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains patches for 2.6 series kernels - These are intended for
 use with kernel-package and a virgin Linux source tree. Note: These patches
 include the base adeos-ipipe patch along with all the additional material
 normally added by the prepare-kernel.sh script.
 .
 This package contains the following patches:
 .

Package: libxenomai1
Section: libs
Architecture: amd64 arm armeb armel i386 powerpc
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: linux-patch-xenomai, xenomai-doc
Replaces: xenomai
Conflicts: xenomai
Breaks: udev (<< 136-1)
Description: Shared libraries for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains the shared libraries.

Package: libxenomai-dev
Section: libdevel
Architecture: amd64 arm armeb armel i386 powerpc
Depends: libxenomai1 (= ${binary:Version}), ${misc:Depends}
Suggests: linux-patch-xenomai, xenomai-doc
Replaces: xenomai
Conflicts: xenomai
Description: Headers and static libs for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains development files (header files), the static libraries
 and scripts used to compile realtime applications.

Package: xenomai-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: xenomai
Conflicts: xenomai-docs
Replaces: xenomai-docs
Description: Xenomai documentation
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 Documentation for Xenomai realtime API.

=== debian/rules ===
#!/usr/bin/make -f

# Author: Paul Corner <paul_c@gna.org>
# Created on: Sat Mar 3 12:00 GMT 2007
# License: GPL Ver. 2

#export DH_VERBOSE=1

DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE=$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq ($(DEB_HOST_ARCH), i386)
# Note: Would like to use --includedir=/usr/include/xenomai, but
# there appears to be a `make install` problem.
	CONFIG_OPTS = \
	            --enable-x86-tsc
endif
ifeq ($(DEB_HOST_ARCH), amd64)
	CONFIG_OPTS = \
	            --enable-smp \
	            --enable-x86-tsc \
	            --enable-x86-sep
endif
ifeq ($(DEB_HOST_ARCH), powerpc)
	CONFIG_OPTS =
endif
ifeq ($(DEB_HOST_ARCH), armeb)
	CONFIG_OPTS = --enable-arm-mach=generic --enable-arm-eabi
endif
ifeq ($(DEB_HOST_ARCH), armel)
	CONFIG_OPTS = --enable-arm-mach=omap3 --enable-arm-eabi
endif
ifeq ($(DEB_HOST_ARCH), arm)
	CONFIG_OPTS = --enable-arm-mach=generic
endif
	CONFIG_OPTS += --prefix=/usr \
	            --includedir=/usr/include/xenomai \
	            --mandir=/usr/share/man \
		    --with-testdir=/usr/lib/xenomai

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	CONFIG_OPTS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
	CONFIG_OPTS += --build $(DEB_BUILD_GNU_TYPE)
endif

build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: config.status patch-stamp
	dh_testdir
	$(MAKE)
	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: config.status
	dh_testdir
	touch build-indep-stamp

patch-stamp:
	dh_testdir
	cp debian/linux-patch-xenomai.kpatches.in debian/linux-patch-xenomai.kpatches
	for i in arm i386 powerpc x86_64 x86 ; do \
		bash $(CURDIR)/scripts/prepare-patch.sh $$i ; \
	done
	touch patch-stamp

config.status: configure-stamp
configure-stamp:
	dh_testdir
	./configure $(CONFIG_OPTS)
	touch configure-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f *-stamp
	dh_clean
	if test -f Makefile ; then \
	    $(MAKE) distclean ; \
	fi
	rm -fR $(CURDIR)/tmp
	rm -f $(CURDIR)/*.patch
	rm -f $(CURDIR)/debian/*.kpatches

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp/
	dh_install --sourcedir=$(CURDIR)/debian/tmp
	# xeno-config should be only in libxenomai-dev
	rm -f $(CURDIR)/debian/xenomai-runtime/usr/bin/xeno-config
	rm -f $(CURDIR)/debian/xenomai-runtime/usr/share/man/man1/xeno-config.1
	: > $(CURDIR)/debian/libxenomai1.udev
	for f in $(CURDIR)/ksrc/nucleus/udev/*.rules ; do \
	    cat $$f >> $(CURDIR)/debian/libxenomai1.udev ; \
	done
	install -m 644 debian/libxenomai1.modprobe $(CURDIR)/debian/libxenomai1/etc/modprobe.d/xenomai.conf
	# remove empty directory
	rm -rf $(CURDIR)/debian/xenomai-doc/usr/share/doc/xenomai-doc/ps
	cp debian/libxenomai1.lintian $(CURDIR)/debian/libxenomai1/usr/share/lintian/overrides/libxenomai1
	cp debian/libxenomai-dev.lintian $(CURDIR)/debian/libxenomai-dev/usr/share/lintian/overrides/libxenomai-dev
	dh_installkpatches

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i -A CREDITS README.INSTALL TROUBLESHOOTING
	dh_link -i
	dh_installchangelogs -i
	dh_strip -i
	dh_compress -i -X.pdf
	dh_fixperms -i
	dh_makeshlibs -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
#	 Here follows a little hackery to insert the patch list        
#	 into the control file for linux-patch-xenomai
	cat $(CURDIR)/debian/linux-patch-xenomai.kpatches | \
	    sed -e 's/^$$/./;s/^/ /' >> \
	        $(CURDIR)/debian/linux-patch-xenomai/DEBIAN/control
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -s
	dh_testroot -s
	dh_installinit -s --name=xenomai
	dh_installman -s
	dh_installdocs -s -A CREDITS README.INSTALL TROUBLESHOOTING
	dh_installudev
	dh_link -s
	dh_installchangelogs -s
	dh_strip -s
	dh_compress -s
	dh_fixperms -s
	dh_makeshlibs -s
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s
#	 Echo config options to control.
	echo " ." >> $(CURDIR)/debian/libxenomai1/DEBIAN/control
	echo " Compiled with the following options." >> \
	        $(CURDIR)/debian/libxenomai1/DEBIAN/control
	echo "$(CONFIG_OPTS)" | awk '{ for ( i=1 ; i<=NF ; i++ ) print "   "$$i }' >> \
	        $(CURDIR)/debian/libxenomai1/DEBIAN/control
#	 End of hackery.
	dh_md5sums -s
	dh_builddeb -s

# We have nothing to do by default.

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## xenomai 2.6.0

=== examples/posix/Makefile ===
--- 
+++ 
@@ -92,7 +92,5 @@
 clean::
 	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers Module.markers modules.order
 	$(RM) -R .tmp*
-	$(RM) .runinfo
 
 endif
-

=== ksrc/drivers/can/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
-ifeq ($(PATCHLEVEL),6)
+ifneq ($(VERSION).$(PATCHLEVEL),2.4)
 
-# Makefile frag for Linux v2.6
+# Makefile frag for Linux v2.6 and v3.x
 
 EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai -Idrivers/xenomai/can

=== ksrc/drivers/serial/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

obj-$(CONFIG_XENO_DRIVERS_16550A) += xeno_16550A.o

xeno_16550A-y := 16550A.o

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_DRIVERS_16550A) := xeno_16550A.o

xeno_16550A-objs := 16550A.o

export-objs := $(xeno_16550A-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_16550A.o: $(xeno_16550A-objs)
	$(LD) -r -o $@ $(xeno_16550A-objs)

endif

=== ksrc/drivers/can/sja1000/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai -Idrivers/xenomai/can -Idrivers/xenomai/can/sja1000

obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000) += xeno_can_sja1000.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_PEAK_PCI) += xeno_can_peak_pci.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_PEAK_DNG) += xeno_can_peak_dng.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_PLX_PCI) += xeno_can_plx_pci.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_IXXAT_PCI) += xeno_can_ixxat_pci.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_EMS_PCI) += xeno_can_ems_pci.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_ESD_PCI) += xeno_can_esd_pci.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_ISA) += xeno_can_isa.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_MEM) += xeno_can_mem.o

xeno_can_sja1000-y := rtcan_sja1000.o rtcan_sja1000_proc.o
xeno_can_peak_pci-y := rtcan_peak_pci.o
xeno_can_peak_dng-y := rtcan_peak_dng.o
xeno_can_plx_pci-y := rtcan_plx_pci.o
xeno_can_ixxat_pci-y := rtcan_ixxat_pci.o
xeno_can_ems_pci-y := rtcan_ems_pci.o
xeno_can_esd_pci-y := rtcan_esd_pci.o
xeno_can_isa-y := rtcan_isa.o
xeno_can_mem-y := rtcan_mem.o

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000) += xeno_can_sja1000.o 
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_PEAK_PCI) += xeno_can_peak_pci.o 
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_PEAK_DNG) += xeno_can_peak_dng.o 
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_PLX_PCI) += xeno_can_plx_pci.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_IXXAT_PCI) += xeno_can_ixxat_pci.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_EMS_PCI) += xeno_can_ems_pci.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_ESD_PCI) += xeno_can_esd_pci.o
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_ISA) += xeno_can_isa.o 
obj-$(CONFIG_XENO_DRIVERS_CAN_SJA1000_MEM) += xeno_can_mem.o

list-multi := xeno_can_sja1000.o 

xeno_can_sja1000-objs := rtcan_sja1000.o rtcan_sja1000_proc.o
xeno_can_peak_pci-objs := rtcan_peak_pci.o
xeno_can_peak_dng-objs := rtcan_peak_dng.o
xeno_can_plx_pci-objs := rtcan_plx_pci.o
xeno_can_ixxat_pci-objs := rtcan_ixxat_pci.o
xeno_can_ems_pci-objs := rtcan_ems_pci.o
xeno_can_esd_pci-objs := rtcan_esd_pci.o
xeno_can_isa-objs := rtcan_isa.o
xeno_can_mem-objs := rtcan_mem.o

export-objs := $(xeno_can_sja1000-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat -I..  -I.

include $(TOPDIR)/Rules.make

xeno_can_sja1000.o: $(xeno_can_sja1000-objs)
	$(LD) -r -o $@ $(xeno_can_sja1000-objs)

xeno_can_peak_pci.o: $(xeno_can_peak_pci-objs)
	$(LD) -r -o $@ $(xeno_can_peak_pci-objs)

xeno_can_peak_dng.o: $(xeno_can_peak_dng-objs)
	$(LD) -r -o $@ $(xeno_can_peak_dng-objs)

xeno_can_plx_pci.o: $(xeno_can_plx_pci-objs)
	$(LD) -r -o $@ $(xeno_can_plx_pci-objs)

xeno_can_ixxat_pci.o: $(xeno_can_ixxat_pci-objs)
	$(LD) -r -o $@ $(xeno_can_ixxat_pci-objs)

xeno_can_ems_pci.o: $(xeno_can_ems_pci-objs)
	$(LD) -r -o $@ $(xeno_can_ems_pci-objs)

xeno_can_esd_pci.o: $(xeno_can_esd_pci-objs)
	$(LD) -r -o $@ $(xeno_can_esd_pci-objs)

xeno_can_isa.o: $(xeno_can_isa-objs)
	$(LD) -r -o $@ $(xeno_can_isa-objs)

xeno_can_mem.o: $(xeno_can_mem-objs)
	$(LD) -r -o $@ $(xeno_can_mem-objs)
endif

=== debian/changelog ===
xenomai (2.6.0-2) unstable; urgency=low

  * Add patch from upstream, fixing a bug in clock_nanosleep (Closes: #677633)
    Comment from patch author:
      Note however that with xenomai, a signal received during nanosleep will
      trigger a switch to secondary mode. So, this usage is only possible for
      a real-time thread in exceptional conditions (to handle an error for
      instance), not when latency matters.
  * debian/control: Standards-Version: 3.9.3

 -- Roland Stigge <stigge@antcom.de>  Sat, 16 Jun 2012 17:10:54 +0200

xenomai (2.6.0-1) unstable; urgency=low

  * New upstream release
  * Needed to autoreconf, adding necessary build-dependencies

 -- Roland Stigge <stigge@antcom.de>  Sun, 06 Nov 2011 15:32:52 +0100

xenomai (2.5.6-3) unstable; urgency=low

  * Added -fno-ommit-frame-pointer to build, necessary from gcc 4.6 on
    (Closes: #637425)
  * Removed *.la files from libxenomai-dev

 -- Roland Stigge <stigge@antcom.de>  Fri, 12 Aug 2011 20:39:11 +0200

xenomai (2.5.6-2) unstable; urgency=low

  * Removed usage of dh-kpatches in the build process (and from Build-Depends)
    since this package will probably be removed from Debian (and make-kpkg
    doesn't support automatic patching anymore anyway)
  * Standards-Version: 3.9.2
  * debhelper compatibility level 8

 -- Roland Stigge <stigge@antcom.de>  Wed, 04 May 2011 11:09:19 +0200

xenomai (2.5.6-1) unstable; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Thu, 07 Apr 2011 17:52:24 +0200

=== debian/rules ===
--- 
+++ 
@@ -30,7 +30,7 @@
 	CONFIG_OPTS = --enable-arm-mach=generic --enable-arm-eabi
 endif
 ifeq ($(DEB_HOST_ARCH), armel)
-	CONFIG_OPTS = --enable-arm-mach=omap3 --enable-arm-eabi
+	CONFIG_OPTS = --enable-arm-mach=generic --enable-arm-eabi
 endif
 ifeq ($(DEB_HOST_ARCH), arm)
 	CONFIG_OPTS = --enable-arm-mach=generic
@@ -46,10 +46,13 @@
 	CONFIG_OPTS += --build $(DEB_BUILD_GNU_TYPE)
 endif
 
+# necessary from GCC 4.6 on
+CFLAGS += -fno-omit-frame-pointer
+
 build: build-arch build-indep
 
 build-arch: build-arch-stamp
-build-arch-stamp: config.status patch-stamp
+build-arch-stamp: config.status xenomai-patch-stamp
 	dh_testdir
 	$(MAKE)
 	touch build-arch-stamp
@@ -59,31 +62,31 @@
 	dh_testdir
 	touch build-indep-stamp
 
-patch-stamp:
+xenomai-patch-stamp:
 	dh_testdir
-	cp debian/linux-patch-xenomai.kpatches.in debian/linux-patch-xenomai.kpatches
 	for i in arm i386 powerpc x86_64 x86 ; do \
 		bash $(CURDIR)/scripts/prepare-patch.sh $$i ; \
 	done
-	touch patch-stamp
+	touch xenomai-patch-stamp
 
 config.status: configure-stamp
 configure-stamp:
 	dh_testdir
-	./configure $(CONFIG_OPTS)
+	autoreconf -fi
+	./configure $(CONFIG_OPTS) --with-testdir=/usr/lib/xenomai/testsuite
 	touch configure-stamp
 
 clean:
 	dh_testdir
 	dh_testroot
-	rm -f *-stamp
-	dh_clean
-	if test -f Makefile ; then \
+	rm -f configure-stamp xenomai-patch-stamp build-indep-stamp build-arch-stamp
+	-if test -f Makefile ; then \
 	    $(MAKE) distclean ; \
 	fi
+	dh_clean
 	rm -fR $(CURDIR)/tmp
 	rm -f $(CURDIR)/*.patch
-	rm -f $(CURDIR)/debian/*.kpatches
+	-rm -f configure
 
 install: build
 	dh_testdir
@@ -92,19 +95,21 @@
 	dh_installdirs
 	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp/
 	dh_install --sourcedir=$(CURDIR)/debian/tmp
+	# Patch collection:
+	cp adeos-ipipe-*.patch $(CURDIR)/debian/linux-patch-xenomai/usr/src/kernel-patches/diffs/xenomai
 	# xeno-config should be only in libxenomai-dev
 	rm -f $(CURDIR)/debian/xenomai-runtime/usr/bin/xeno-config
 	rm -f $(CURDIR)/debian/xenomai-runtime/usr/share/man/man1/xeno-config.1
-	: > $(CURDIR)/debian/libxenomai1.udev
 	for f in $(CURDIR)/ksrc/nucleus/udev/*.rules ; do \
-	    cat $$f >> $(CURDIR)/debian/libxenomai1.udev ; \
+	    cat $$f >> $(CURDIR)/debian/libxenomai1/etc/udev/xenomai.rules ; \
 	done
 	install -m 644 debian/libxenomai1.modprobe $(CURDIR)/debian/libxenomai1/etc/modprobe.d/xenomai.conf
 	# remove empty directory
 	rm -rf $(CURDIR)/debian/xenomai-doc/usr/share/doc/xenomai-doc/ps
 	cp debian/libxenomai1.lintian $(CURDIR)/debian/libxenomai1/usr/share/lintian/overrides/libxenomai1
 	cp debian/libxenomai-dev.lintian $(CURDIR)/debian/libxenomai-dev/usr/share/lintian/overrides/libxenomai-dev
-	dh_installkpatches
+	# remove *.la files
+	rm $(CURDIR)/debian/libxenomai-dev/usr/lib/*.la
 
 # Build architecture-independent files here.
 binary-indep: build install
@@ -114,17 +119,12 @@
 	dh_link -i
 	dh_installchangelogs -i
 	dh_strip -i
-	dh_compress -i -X.pdf
+	dh_compress -i -X.pdf $(CURDIR)/debian/linux-patch-xenomai/usr/src/kernel-patches/diffs/xenomai/*
 	dh_fixperms -i
 	dh_makeshlibs -i
 	dh_installdeb -i
 	dh_shlibdeps -i
 	dh_gencontrol -i
-#	 Here follows a little hackery to insert the patch list        
-#	 into the control file for linux-patch-xenomai
-	cat $(CURDIR)/debian/linux-patch-xenomai.kpatches | \
-	    sed -e 's/^$$/./;s/^/ /' >> \
-	        $(CURDIR)/debian/linux-patch-xenomai/DEBIAN/control
 	dh_md5sums -i
 	dh_builddeb -i
 
@@ -135,7 +135,6 @@
 	dh_installinit -s --name=xenomai
 	dh_installman -s
 	dh_installdocs -s -A CREDITS README.INSTALL TROUBLESHOOTING
-	dh_installudev
 	dh_link -s
 	dh_installchangelogs -s
 	dh_strip -s
